<template>
  <div class="xand-modal">
    <header class="xand-modal-header">
      <button v-if="backEnabled" type="button" class="xand-modal-back" @click="back">
        <i class="icon-back xand-header-icon"></i>
      </button>
      <slot name="header">
        <h3 class="xand-modal-title">{{title}}</h3>
      </slot>
      <button type="button" class="xand-modal-close" @click="close">
        <i class="icon-close xand-header-icon"></i>
      </button>
    </header>
    <div class="xand-modal-content" :class="{'has-footer': this.$slots.footer}">
      <slot name="content">Modal Body Content</slot>
    </div>
    <footer class="xand-modal-footer" v-if="this.$slots.footer">
      <slot name="footer" />
    </footer>
  </div>
</template>

<script lang="ts">
import "reflect-metadata";
import { Vue, Component, Prop } from "vue-property-decorator";

@Component({
  inheritAttrs: false
})
export default class BaseModal extends Vue {
  @Prop({ default: "Modal Header Title" }) public readonly title!: string;
  @Prop({ default: false }) public readonly backEnabled!: boolean;

  public close() {
    this.$emit("close");
  }

  public back() {
    this.$emit("back");
  }
}
</script>

<style lang="scss" scoped>
$basePadding: 1rem;

.xand-modal {
  width: 370px;
  max-width: 420px;
  max-height: 90vh;
  position: relative;
  overflow: hidden;
  border-radius: 4px;
  margin: 0 auto;
  background-color: #fff;
  display: flex;
  flex-direction: column;
  box-sizing: border-box;
}

.xand-modal-header {
  padding: $basePadding;
  position: relative;
  min-height: 3.5rem;
  display: flex;
  margin: 0;
  justify-content: space-between;
  box-sizing: border-box;
  align-items: center;
}

.xand-modal-content {
  max-height: 80vh;
  overflow: auto;
  position: relative;
  padding: 0;
  margin: 0;
  display: flex;
  flex: 1 1 auto;
  overflow: auto;
  box-sizing: border-box;
  border-top: 1px solid $separationborderColor;
}

.has-footer {
  border-bottom: 1px solid $separationborderColor;
}

.xand-modal-close {
  align-self: flex-start;
  cursor: pointer;
  background-color: transparent;
  border: 0;
  color: $darkGray;
  text-shadow: 0 1px 0 #fff;
  opacity: 0.5;
  position: absolute;
  right: $basePadding;
}

.xand-modal-back {
  cursor: pointer;
  background-color: transparent;
  border: 0;
  color: $darkGray;
  text-shadow: 0 1px 0 #fff;
  position: absolute;
  left: $basePadding;
}

.xand-modal-footer {
  padding: $basePadding;
}

.xand-modal-title {
  font-size: $lgTitleSize;
  margin: 0;
  flex: 1;
  text-align: center;
}

.xand-header-icon {
  font-size: $buttonFontSize;
}
</style>
